AddDensity( name="f0", dx= 0, dy= 0, group="f" )
AddDensity( name="f1", dx= 1, dy= 0, group="f" )
AddDensity( name="f2", dx= 0, dy= 1, group="f" )
AddDensity( name="f3", dx=-1, dy= 0, group="f" )
AddDensity( name="f4", dx= 0, dy=-1, group="f" )
AddDensity( name="f5", dx= 1, dy= 1, group="f" )
AddDensity( name="f6", dx=-1, dy= 1, group="f" )
AddDensity( name="f7", dx=-1, dy=-1, group="f" )
AddDensity( name="f8", dx= 1, dy=-1, group="f" )
AddDensity( name="w", group="w", parameter=T )

AddQuantity( name="Rho",unit="kg/m3")
AddQuantity( name="U",unit="m/s",vector=T)
AddQuantity( name="RhoB",adjoint=T)
AddQuantity( name="UB",adjoint=T,vector=T)
AddQuantity( name="W")
AddQuantity( name="WB",adjoint=T)

AddSetting(name="tau0", comment='one over relaxation time')
AddSetting(name="nu", tau0='3*nu + 0.5', default=0.16666666, comment='viscosity')

AddSetting(name="Velocity", default=0, comment='inlet/outlet/init velocity', zonal=T)
AddSetting(name="Density", default=1, comment='inlet/outlet/init density', zonal=T)
AddSetting(name="Smag", default=1, comment='inlet density')

AddGlobal(name="PressDiff", comment='pressure loss')
AddGlobal(name="TotalPressureFlux", comment='pressure loss')
AddGlobal(name="OutletFlux", comment='pressure loss')
AddGlobal(name="InletPressureIntegral", comment='pressure loss')

AddNodeType(name="Inlet", group="OBJECTIVE")
AddNodeType(name="Outlet", group="OBJECTIVE")
AddNodeType(name="EPressure", group="BOUNDARY")
AddNodeType(name="EVelocity", group="BOUNDARY")
AddNodeType(name="Solid", group="BOUNDARY")
AddNodeType(name="Wall", group="BOUNDARY")
AddNodeType(name="WPressure", group="BOUNDARY")
AddNodeType(name="WVelocity", group="BOUNDARY")
AddNodeType(name="BGK", group="COLLISION")
AddNodeType(name="MRT", group="COLLISION")
